Subject: bug#13609: closed (Re: bug#13609: 24.2.92; completion-list-insert-choice-function)

From: [email-masked] (GNU bug Tracking System)
Date: Sun, 03 Feb 2013 15:48:02 +0000

Your bug report

#13609: 24.2.92; completion-list-insert-choice-function

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
13609: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=13609
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#13609: 24.2.92; completion-list-insert-choice-function
From: "Roland Winkler" <[email-masked]>
To: Stefan Monnier <[email-masked]>
Cc: [email-masked]
Date: Sun, 3 Feb 2013 09:46:49 -0600
List-Id: <debbugs-submit.debbugs.gnu.org>

On Sun Feb 3 2013 Stefan Monnier wrote:
> > So I suggest to rename completion--replace to completion-replace
> > to make it clear that other code may use this function.
> 
> No, because some other package may already have changed
> completion-list-insert-choice-function, so you should really read the
> current value of completion-list-insert-choice-function, and then call
> that (via `funcall') rather than hard-coding completion--replace.

Thank you, that makes sense, it solves my problem.

Possibly, such a strategy could even be mentioned in the docstring of
completion-list-insert-choice-function.  How about adding the
following sentences?

  If you want to bind this variable to a function calling the default
  value of this variable as part of its job, do not hard-code this value
  in your code as it may change in future versions of Emacs.
  Instead, read the current value of completion-list-insert-choice-function,
  then call that via `funcall'.

Of course, this is a generic issue with any foo-function variables
that come with a default.  Merely, I do not know where to put such
a more generic remark into the elisp manual so that you find it
when you need it.

> > (Or solve this problem in some other way that other code may rely upon.)
> 
> As a matter of fact there's a new feature in trunk that does just that:
> `add-function'.

Great, though I'll keep this for future versions of BBDB.  Right now
I want to keep BBDB 3 compatible with GNU Emacs 23 and 24.
(Sometimes this is hard when you have to ignore cool new stuff...)

Roland

Subject: 24.2.92; completion-list-insert-choice-function
From: "Roland Winkler" <[email-masked]>
To: [email-masked]
Date: Sat, 02 Feb 2013 10:24:57 -0600
List-Id: <debbugs-submit.debbugs.gnu.org>

The default value of completion-list-insert-choice-function
is completion--replace.  The `--' in the name of completion--replace
suggests to me that this is an internal function other code
should not rely on.  Yet isn't it a common scenario to bind
completion-list-insert-choice-function to a function which
calls completion--replace, plus it does something else?
(This is what bbdb-complete-mail does in BBDB v3.)

So I suggest to rename completion--replace to completion-replace
to make it clear that other code may use this function.
(Or solve this problem in some other way that other code may rely upon.)

In GNU Emacs 24.2.92.1 (x86_64-unknown-linux-gnu, GTK+ Version 2.20.1)
 of 2013-01-10 on regnitz
Windowing system distributor `The X.Org Foundation', version 11.0.10706000
System Description:	Ubuntu 10.04.4 LTS